# This Python file uses the following encoding: utf-8
"""autogenerated by genpy from foxglove_msgs/ImageAnnotations.msg. Do not edit."""
import codecs
import sys
python3 = True if sys.hexversion > 0x03000000 else False
import genpy
import struct

import foxglove_msgs.msg
import genpy

class ImageAnnotations(genpy.Message):
  _md5sum = "685a869995712c54b6863409ecf414b1"
  _type = "foxglove_msgs/ImageAnnotations"
  _has_header = False  # flag to mark the presence of a Header object
  _full_text = """# foxglove_msgs/ImageAnnotations
# Array of annotations for a 2D image

# Generated by https://github.com/foxglove/schemas

# Circle annotations
foxglove_msgs/CircleAnnotation[] circles

# Points annotations
foxglove_msgs/PointsAnnotation[] points

# Text annotations
foxglove_msgs/TextAnnotation[] texts

================================================================================
MSG: foxglove_msgs/CircleAnnotation
# foxglove_msgs/CircleAnnotation
# A circle annotation on a 2D image

# Generated by https://github.com/foxglove/schemas

# Timestamp of circle
time timestamp

# Center of the circle in 2D image coordinates (pixels)
foxglove_msgs/Point2 position

# Circle diameter in pixels
float64 diameter

# Line thickness in pixels
float64 thickness

# Fill color
foxglove_msgs/Color fill_color

# Outline color
foxglove_msgs/Color outline_color

================================================================================
MSG: foxglove_msgs/Point2
# foxglove_msgs/Point2
# A point representing a position in 2D space

# Generated by https://github.com/foxglove/schemas

# x coordinate position
float64 x

# y coordinate position
float64 y

================================================================================
MSG: foxglove_msgs/Color
# foxglove_msgs/Color
# A color in RGBA format

# Generated by https://github.com/foxglove/schemas

# Red value between 0 and 1
float64 r

# Green value between 0 and 1
float64 g

# Blue value between 0 and 1
float64 b

# Alpha value between 0 and 1
float64 a

================================================================================
MSG: foxglove_msgs/PointsAnnotation
# foxglove_msgs/PointsAnnotation
# An array of points on a 2D image

# Generated by https://github.com/foxglove/schemas

# Timestamp of annotation
time timestamp

uint8 UNKNOWN=0

# Individual points: 0, 1, 2, ...
uint8 POINTS=1

# Closed polygon: 0-1, 1-2, ..., (n-1)-n, n-0
uint8 LINE_LOOP=2

# Connected line segments: 0-1, 1-2, ..., (n-1)-n
uint8 LINE_STRIP=3

# Individual line segments: 0-1, 2-3, 4-5, ...
uint8 LINE_LIST=4

# Type of points annotation to draw
uint8 type

# Points in 2D image coordinates (pixels)
foxglove_msgs/Point2[] points

# Outline color
foxglove_msgs/Color outline_color

# Per-point colors, if `type` is `POINTS`, or per-segment stroke colors, if `type` is `LINE_LIST`, `LINE_STRIP` or `LINE_LOOP`.
foxglove_msgs/Color[] outline_colors

# Fill color
foxglove_msgs/Color fill_color

# Stroke thickness in pixels
float64 thickness

================================================================================
MSG: foxglove_msgs/TextAnnotation
# foxglove_msgs/TextAnnotation
# A text label on a 2D image

# Generated by https://github.com/foxglove/schemas

# Timestamp of annotation
time timestamp

# Bottom-left origin of the text label in 2D image coordinates (pixels)
foxglove_msgs/Point2 position

# Text to display
string text

# Font size in pixels
float64 font_size

# Text color
foxglove_msgs/Color text_color

# Background fill color
foxglove_msgs/Color background_color
"""
  __slots__ = ['circles','points','texts']
  _slot_types = ['foxglove_msgs/CircleAnnotation[]','foxglove_msgs/PointsAnnotation[]','foxglove_msgs/TextAnnotation[]']

  def __init__(self, *args, **kwds):
    """
    Constructor. Any message fields that are implicitly/explicitly
    set to None will be assigned a default value. The recommend
    use is keyword arguments as this is more robust to future message
    changes.  You cannot mix in-order arguments and keyword arguments.

    The available fields are:
       circles,points,texts

    :param args: complete set of field values, in .msg order
    :param kwds: use keyword arguments corresponding to message field names
    to set specific fields.
    """
    if args or kwds:
      super(ImageAnnotations, self).__init__(*args, **kwds)
      # message fields cannot be None, assign default values for those that are
      if self.circles is None:
        self.circles = []
      if self.points is None:
        self.points = []
      if self.texts is None:
        self.texts = []
    else:
      self.circles = []
      self.points = []
      self.texts = []

  def _get_types(self):
    """
    internal API method
    """
    return self._slot_types

  def serialize(self, buff):
    """
    serialize message into buffer
    :param buff: buffer, ``StringIO``
    """
    try:
      length = len(self.circles)
      buff.write(_struct_I.pack(length))
      for val1 in self.circles:
        _v1 = val1.timestamp
        _x = _v1
        buff.write(_get_struct_2I().pack(_x.secs, _x.nsecs))
        _v2 = val1.position
        _x = _v2
        buff.write(_get_struct_2d().pack(_x.x, _x.y))
        _x = val1
        buff.write(_get_struct_2d().pack(_x.diameter, _x.thickness))
        _v3 = val1.fill_color
        _x = _v3
        buff.write(_get_struct_4d().pack(_x.r, _x.g, _x.b, _x.a))
        _v4 = val1.outline_color
        _x = _v4
        buff.write(_get_struct_4d().pack(_x.r, _x.g, _x.b, _x.a))
      length = len(self.points)
      buff.write(_struct_I.pack(length))
      for val1 in self.points:
        _v5 = val1.timestamp
        _x = _v5
        buff.write(_get_struct_2I().pack(_x.secs, _x.nsecs))
        _x = val1.type
        buff.write(_get_struct_B().pack(_x))
        length = len(val1.points)
        buff.write(_struct_I.pack(length))
        for val2 in val1.points:
          _x = val2
          buff.write(_get_struct_2d().pack(_x.x, _x.y))
        _v6 = val1.outline_color
        _x = _v6
        buff.write(_get_struct_4d().pack(_x.r, _x.g, _x.b, _x.a))
        length = len(val1.outline_colors)
        buff.write(_struct_I.pack(length))
        for val2 in val1.outline_colors:
          _x = val2
          buff.write(_get_struct_4d().pack(_x.r, _x.g, _x.b, _x.a))
        _v7 = val1.fill_color
        _x = _v7
        buff.write(_get_struct_4d().pack(_x.r, _x.g, _x.b, _x.a))
        _x = val1.thickness
        buff.write(_get_struct_d().pack(_x))
      length = len(self.texts)
      buff.write(_struct_I.pack(length))
      for val1 in self.texts:
        _v8 = val1.timestamp
        _x = _v8
        buff.write(_get_struct_2I().pack(_x.secs, _x.nsecs))
        _v9 = val1.position
        _x = _v9
        buff.write(_get_struct_2d().pack(_x.x, _x.y))
        _x = val1.text
        length = len(_x)
        if python3 or type(_x) == unicode:
          _x = _x.encode('utf-8')
          length = len(_x)
        buff.write(struct.Struct('<I%ss'%length).pack(length, _x))
        _x = val1.font_size
        buff.write(_get_struct_d().pack(_x))
        _v10 = val1.text_color
        _x = _v10
        buff.write(_get_struct_4d().pack(_x.r, _x.g, _x.b, _x.a))
        _v11 = val1.background_color
        _x = _v11
        buff.write(_get_struct_4d().pack(_x.r, _x.g, _x.b, _x.a))
    except struct.error as se: self._check_types(struct.error("%s: '%s' when writing '%s'" % (type(se), str(se), str(locals().get('_x', self)))))
    except TypeError as te: self._check_types(ValueError("%s: '%s' when writing '%s'" % (type(te), str(te), str(locals().get('_x', self)))))

  def deserialize(self, str):
    """
    unpack serialized message in str into this message instance
    :param str: byte array of serialized message, ``str``
    """
    if python3:
      codecs.lookup_error("rosmsg").msg_type = self._type
    try:
      if self.circles is None:
        self.circles = None
      if self.points is None:
        self.points = None
      if self.texts is None:
        self.texts = None
      end = 0
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      self.circles = []
      for i in range(0, length):
        val1 = foxglove_msgs.msg.CircleAnnotation()
        _v12 = val1.timestamp
        _x = _v12
        start = end
        end += 8
        (_x.secs, _x.nsecs,) = _get_struct_2I().unpack(str[start:end])
        _v13 = val1.position
        _x = _v13
        start = end
        end += 16
        (_x.x, _x.y,) = _get_struct_2d().unpack(str[start:end])
        _x = val1
        start = end
        end += 16
        (_x.diameter, _x.thickness,) = _get_struct_2d().unpack(str[start:end])
        _v14 = val1.fill_color
        _x = _v14
        start = end
        end += 32
        (_x.r, _x.g, _x.b, _x.a,) = _get_struct_4d().unpack(str[start:end])
        _v15 = val1.outline_color
        _x = _v15
        start = end
        end += 32
        (_x.r, _x.g, _x.b, _x.a,) = _get_struct_4d().unpack(str[start:end])
        self.circles.append(val1)
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      self.points = []
      for i in range(0, length):
        val1 = foxglove_msgs.msg.PointsAnnotation()
        _v16 = val1.timestamp
        _x = _v16
        start = end
        end += 8
        (_x.secs, _x.nsecs,) = _get_struct_2I().unpack(str[start:end])
        start = end
        end += 1
        (val1.type,) = _get_struct_B().unpack(str[start:end])
        start = end
        end += 4
        (length,) = _struct_I.unpack(str[start:end])
        val1.points = []
        for i in range(0, length):
          val2 = foxglove_msgs.msg.Point2()
          _x = val2
          start = end
          end += 16
          (_x.x, _x.y,) = _get_struct_2d().unpack(str[start:end])
          val1.points.append(val2)
        _v17 = val1.outline_color
        _x = _v17
        start = end
        end += 32
        (_x.r, _x.g, _x.b, _x.a,) = _get_struct_4d().unpack(str[start:end])
        start = end
        end += 4
        (length,) = _struct_I.unpack(str[start:end])
        val1.outline_colors = []
        for i in range(0, length):
          val2 = foxglove_msgs.msg.Color()
          _x = val2
          start = end
          end += 32
          (_x.r, _x.g, _x.b, _x.a,) = _get_struct_4d().unpack(str[start:end])
          val1.outline_colors.append(val2)
        _v18 = val1.fill_color
        _x = _v18
        start = end
        end += 32
        (_x.r, _x.g, _x.b, _x.a,) = _get_struct_4d().unpack(str[start:end])
        start = end
        end += 8
        (val1.thickness,) = _get_struct_d().unpack(str[start:end])
        self.points.append(val1)
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      self.texts = []
      for i in range(0, length):
        val1 = foxglove_msgs.msg.TextAnnotation()
        _v19 = val1.timestamp
        _x = _v19
        start = end
        end += 8
        (_x.secs, _x.nsecs,) = _get_struct_2I().unpack(str[start:end])
        _v20 = val1.position
        _x = _v20
        start = end
        end += 16
        (_x.x, _x.y,) = _get_struct_2d().unpack(str[start:end])
        start = end
        end += 4
        (length,) = _struct_I.unpack(str[start:end])
        start = end
        end += length
        if python3:
          val1.text = str[start:end].decode('utf-8', 'rosmsg')
        else:
          val1.text = str[start:end]
        start = end
        end += 8
        (val1.font_size,) = _get_struct_d().unpack(str[start:end])
        _v21 = val1.text_color
        _x = _v21
        start = end
        end += 32
        (_x.r, _x.g, _x.b, _x.a,) = _get_struct_4d().unpack(str[start:end])
        _v22 = val1.background_color
        _x = _v22
        start = end
        end += 32
        (_x.r, _x.g, _x.b, _x.a,) = _get_struct_4d().unpack(str[start:end])
        self.texts.append(val1)
      return self
    except struct.error as e:
      raise genpy.DeserializationError(e)  # most likely buffer underfill


  def serialize_numpy(self, buff, numpy):
    """
    serialize message with numpy array types into buffer
    :param buff: buffer, ``StringIO``
    :param numpy: numpy python module
    """
    try:
      length = len(self.circles)
      buff.write(_struct_I.pack(length))
      for val1 in self.circles:
        _v23 = val1.timestamp
        _x = _v23
        buff.write(_get_struct_2I().pack(_x.secs, _x.nsecs))
        _v24 = val1.position
        _x = _v24
        buff.write(_get_struct_2d().pack(_x.x, _x.y))
        _x = val1
        buff.write(_get_struct_2d().pack(_x.diameter, _x.thickness))
        _v25 = val1.fill_color
        _x = _v25
        buff.write(_get_struct_4d().pack(_x.r, _x.g, _x.b, _x.a))
        _v26 = val1.outline_color
        _x = _v26
        buff.write(_get_struct_4d().pack(_x.r, _x.g, _x.b, _x.a))
      length = len(self.points)
      buff.write(_struct_I.pack(length))
      for val1 in self.points:
        _v27 = val1.timestamp
        _x = _v27
        buff.write(_get_struct_2I().pack(_x.secs, _x.nsecs))
        _x = val1.type
        buff.write(_get_struct_B().pack(_x))
        length = len(val1.points)
        buff.write(_struct_I.pack(length))
        for val2 in val1.points:
          _x = val2
          buff.write(_get_struct_2d().pack(_x.x, _x.y))
        _v28 = val1.outline_color
        _x = _v28
        buff.write(_get_struct_4d().pack(_x.r, _x.g, _x.b, _x.a))
        length = len(val1.outline_colors)
        buff.write(_struct_I.pack(length))
        for val2 in val1.outline_colors:
          _x = val2
          buff.write(_get_struct_4d().pack(_x.r, _x.g, _x.b, _x.a))
        _v29 = val1.fill_color
        _x = _v29
        buff.write(_get_struct_4d().pack(_x.r, _x.g, _x.b, _x.a))
        _x = val1.thickness
        buff.write(_get_struct_d().pack(_x))
      length = len(self.texts)
      buff.write(_struct_I.pack(length))
      for val1 in self.texts:
        _v30 = val1.timestamp
        _x = _v30
        buff.write(_get_struct_2I().pack(_x.secs, _x.nsecs))
        _v31 = val1.position
        _x = _v31
        buff.write(_get_struct_2d().pack(_x.x, _x.y))
        _x = val1.text
        length = len(_x)
        if python3 or type(_x) == unicode:
          _x = _x.encode('utf-8')
          length = len(_x)
        buff.write(struct.Struct('<I%ss'%length).pack(length, _x))
        _x = val1.font_size
        buff.write(_get_struct_d().pack(_x))
        _v32 = val1.text_color
        _x = _v32
        buff.write(_get_struct_4d().pack(_x.r, _x.g, _x.b, _x.a))
        _v33 = val1.background_color
        _x = _v33
        buff.write(_get_struct_4d().pack(_x.r, _x.g, _x.b, _x.a))
    except struct.error as se: self._check_types(struct.error("%s: '%s' when writing '%s'" % (type(se), str(se), str(locals().get('_x', self)))))
    except TypeError as te: self._check_types(ValueError("%s: '%s' when writing '%s'" % (type(te), str(te), str(locals().get('_x', self)))))

  def deserialize_numpy(self, str, numpy):
    """
    unpack serialized message in str into this message instance using numpy for array types
    :param str: byte array of serialized message, ``str``
    :param numpy: numpy python module
    """
    if python3:
      codecs.lookup_error("rosmsg").msg_type = self._type
    try:
      if self.circles is None:
        self.circles = None
      if self.points is None:
        self.points = None
      if self.texts is None:
        self.texts = None
      end = 0
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      self.circles = []
      for i in range(0, length):
        val1 = foxglove_msgs.msg.CircleAnnotation()
        _v34 = val1.timestamp
        _x = _v34
        start = end
        end += 8
        (_x.secs, _x.nsecs,) = _get_struct_2I().unpack(str[start:end])
        _v35 = val1.position
        _x = _v35
        start = end
        end += 16
        (_x.x, _x.y,) = _get_struct_2d().unpack(str[start:end])
        _x = val1
        start = end
        end += 16
        (_x.diameter, _x.thickness,) = _get_struct_2d().unpack(str[start:end])
        _v36 = val1.fill_color
        _x = _v36
        start = end
        end += 32
        (_x.r, _x.g, _x.b, _x.a,) = _get_struct_4d().unpack(str[start:end])
        _v37 = val1.outline_color
        _x = _v37
        start = end
        end += 32
        (_x.r, _x.g, _x.b, _x.a,) = _get_struct_4d().unpack(str[start:end])
        self.circles.append(val1)
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      self.points = []
      for i in range(0, length):
        val1 = foxglove_msgs.msg.PointsAnnotation()
        _v38 = val1.timestamp
        _x = _v38
        start = end
        end += 8
        (_x.secs, _x.nsecs,) = _get_struct_2I().unpack(str[start:end])
        start = end
        end += 1
        (val1.type,) = _get_struct_B().unpack(str[start:end])
        start = end
        end += 4
        (length,) = _struct_I.unpack(str[start:end])
        val1.points = []
        for i in range(0, length):
          val2 = foxglove_msgs.msg.Point2()
          _x = val2
          start = end
          end += 16
          (_x.x, _x.y,) = _get_struct_2d().unpack(str[start:end])
          val1.points.append(val2)
        _v39 = val1.outline_color
        _x = _v39
        start = end
        end += 32
        (_x.r, _x.g, _x.b, _x.a,) = _get_struct_4d().unpack(str[start:end])
        start = end
        end += 4
        (length,) = _struct_I.unpack(str[start:end])
        val1.outline_colors = []
        for i in range(0, length):
          val2 = foxglove_msgs.msg.Color()
          _x = val2
          start = end
          end += 32
          (_x.r, _x.g, _x.b, _x.a,) = _get_struct_4d().unpack(str[start:end])
          val1.outline_colors.append(val2)
        _v40 = val1.fill_color
        _x = _v40
        start = end
        end += 32
        (_x.r, _x.g, _x.b, _x.a,) = _get_struct_4d().unpack(str[start:end])
        start = end
        end += 8
        (val1.thickness,) = _get_struct_d().unpack(str[start:end])
        self.points.append(val1)
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      self.texts = []
      for i in range(0, length):
        val1 = foxglove_msgs.msg.TextAnnotation()
        _v41 = val1.timestamp
        _x = _v41
        start = end
        end += 8
        (_x.secs, _x.nsecs,) = _get_struct_2I().unpack(str[start:end])
        _v42 = val1.position
        _x = _v42
        start = end
        end += 16
        (_x.x, _x.y,) = _get_struct_2d().unpack(str[start:end])
        start = end
        end += 4
        (length,) = _struct_I.unpack(str[start:end])
        start = end
        end += length
        if python3:
          val1.text = str[start:end].decode('utf-8', 'rosmsg')
        else:
          val1.text = str[start:end]
        start = end
        end += 8
        (val1.font_size,) = _get_struct_d().unpack(str[start:end])
        _v43 = val1.text_color
        _x = _v43
        start = end
        end += 32
        (_x.r, _x.g, _x.b, _x.a,) = _get_struct_4d().unpack(str[start:end])
        _v44 = val1.background_color
        _x = _v44
        start = end
        end += 32
        (_x.r, _x.g, _x.b, _x.a,) = _get_struct_4d().unpack(str[start:end])
        self.texts.append(val1)
      return self
    except struct.error as e:
      raise genpy.DeserializationError(e)  # most likely buffer underfill

_struct_I = genpy.struct_I
def _get_struct_I():
    global _struct_I
    return _struct_I
_struct_2I = None
def _get_struct_2I():
    global _struct_2I
    if _struct_2I is None:
        _struct_2I = struct.Struct("<2I")
    return _struct_2I
_struct_2d = None
def _get_struct_2d():
    global _struct_2d
    if _struct_2d is None:
        _struct_2d = struct.Struct("<2d")
    return _struct_2d
_struct_4d = None
def _get_struct_4d():
    global _struct_4d
    if _struct_4d is None:
        _struct_4d = struct.Struct("<4d")
    return _struct_4d
_struct_B = None
def _get_struct_B():
    global _struct_B
    if _struct_B is None:
        _struct_B = struct.Struct("<B")
    return _struct_B
_struct_d = None
def _get_struct_d():
    global _struct_d
    if _struct_d is None:
        _struct_d = struct.Struct("<d")
    return _struct_d
