# This Python file uses the following encoding: utf-8
"""autogenerated by genpy from foxglove_msgs/TextAnnotation.msg. Do not edit."""
import codecs
import sys
python3 = True if sys.hexversion > 0x03000000 else False
import genpy
import struct

import foxglove_msgs.msg
import genpy

class TextAnnotation(genpy.Message):
  _md5sum = "c519967875038307b79bf6d8fa469b37"
  _type = "foxglove_msgs/TextAnnotation"
  _has_header = False  # flag to mark the presence of a Header object
  _full_text = """# foxglove_msgs/TextAnnotation
# A text label on a 2D image

# Generated by https://github.com/foxglove/schemas

# Timestamp of annotation
time timestamp

# Bottom-left origin of the text label in 2D image coordinates (pixels)
foxglove_msgs/Point2 position

# Text to display
string text

# Font size in pixels
float64 font_size

# Text color
foxglove_msgs/Color text_color

# Background fill color
foxglove_msgs/Color background_color

================================================================================
MSG: foxglove_msgs/Point2
# foxglove_msgs/Point2
# A point representing a position in 2D space

# Generated by https://github.com/foxglove/schemas

# x coordinate position
float64 x

# y coordinate position
float64 y

================================================================================
MSG: foxglove_msgs/Color
# foxglove_msgs/Color
# A color in RGBA format

# Generated by https://github.com/foxglove/schemas

# Red value between 0 and 1
float64 r

# Green value between 0 and 1
float64 g

# Blue value between 0 and 1
float64 b

# Alpha value between 0 and 1
float64 a
"""
  __slots__ = ['timestamp','position','text','font_size','text_color','background_color']
  _slot_types = ['time','foxglove_msgs/Point2','string','float64','foxglove_msgs/Color','foxglove_msgs/Color']

  def __init__(self, *args, **kwds):
    """
    Constructor. Any message fields that are implicitly/explicitly
    set to None will be assigned a default value. The recommend
    use is keyword arguments as this is more robust to future message
    changes.  You cannot mix in-order arguments and keyword arguments.

    The available fields are:
       timestamp,position,text,font_size,text_color,background_color

    :param args: complete set of field values, in .msg order
    :param kwds: use keyword arguments corresponding to message field names
    to set specific fields.
    """
    if args or kwds:
      super(TextAnnotation, self).__init__(*args, **kwds)
      # message fields cannot be None, assign default values for those that are
      if self.timestamp is None:
        self.timestamp = genpy.Time()
      if self.position is None:
        self.position = foxglove_msgs.msg.Point2()
      if self.text is None:
        self.text = ''
      if self.font_size is None:
        self.font_size = 0.
      if self.text_color is None:
        self.text_color = foxglove_msgs.msg.Color()
      if self.background_color is None:
        self.background_color = foxglove_msgs.msg.Color()
    else:
      self.timestamp = genpy.Time()
      self.position = foxglove_msgs.msg.Point2()
      self.text = ''
      self.font_size = 0.
      self.text_color = foxglove_msgs.msg.Color()
      self.background_color = foxglove_msgs.msg.Color()

  def _get_types(self):
    """
    internal API method
    """
    return self._slot_types

  def serialize(self, buff):
    """
    serialize message into buffer
    :param buff: buffer, ``StringIO``
    """
    try:
      _x = self
      buff.write(_get_struct_2I2d().pack(_x.timestamp.secs, _x.timestamp.nsecs, _x.position.x, _x.position.y))
      _x = self.text
      length = len(_x)
      if python3 or type(_x) == unicode:
        _x = _x.encode('utf-8')
        length = len(_x)
      buff.write(struct.Struct('<I%ss'%length).pack(length, _x))
      _x = self
      buff.write(_get_struct_9d().pack(_x.font_size, _x.text_color.r, _x.text_color.g, _x.text_color.b, _x.text_color.a, _x.background_color.r, _x.background_color.g, _x.background_color.b, _x.background_color.a))
    except struct.error as se: self._check_types(struct.error("%s: '%s' when writing '%s'" % (type(se), str(se), str(locals().get('_x', self)))))
    except TypeError as te: self._check_types(ValueError("%s: '%s' when writing '%s'" % (type(te), str(te), str(locals().get('_x', self)))))

  def deserialize(self, str):
    """
    unpack serialized message in str into this message instance
    :param str: byte array of serialized message, ``str``
    """
    if python3:
      codecs.lookup_error("rosmsg").msg_type = self._type
    try:
      if self.timestamp is None:
        self.timestamp = genpy.Time()
      if self.position is None:
        self.position = foxglove_msgs.msg.Point2()
      if self.text_color is None:
        self.text_color = foxglove_msgs.msg.Color()
      if self.background_color is None:
        self.background_color = foxglove_msgs.msg.Color()
      end = 0
      _x = self
      start = end
      end += 24
      (_x.timestamp.secs, _x.timestamp.nsecs, _x.position.x, _x.position.y,) = _get_struct_2I2d().unpack(str[start:end])
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      start = end
      end += length
      if python3:
        self.text = str[start:end].decode('utf-8', 'rosmsg')
      else:
        self.text = str[start:end]
      _x = self
      start = end
      end += 72
      (_x.font_size, _x.text_color.r, _x.text_color.g, _x.text_color.b, _x.text_color.a, _x.background_color.r, _x.background_color.g, _x.background_color.b, _x.background_color.a,) = _get_struct_9d().unpack(str[start:end])
      self.timestamp.canon()
      return self
    except struct.error as e:
      raise genpy.DeserializationError(e)  # most likely buffer underfill


  def serialize_numpy(self, buff, numpy):
    """
    serialize message with numpy array types into buffer
    :param buff: buffer, ``StringIO``
    :param numpy: numpy python module
    """
    try:
      _x = self
      buff.write(_get_struct_2I2d().pack(_x.timestamp.secs, _x.timestamp.nsecs, _x.position.x, _x.position.y))
      _x = self.text
      length = len(_x)
      if python3 or type(_x) == unicode:
        _x = _x.encode('utf-8')
        length = len(_x)
      buff.write(struct.Struct('<I%ss'%length).pack(length, _x))
      _x = self
      buff.write(_get_struct_9d().pack(_x.font_size, _x.text_color.r, _x.text_color.g, _x.text_color.b, _x.text_color.a, _x.background_color.r, _x.background_color.g, _x.background_color.b, _x.background_color.a))
    except struct.error as se: self._check_types(struct.error("%s: '%s' when writing '%s'" % (type(se), str(se), str(locals().get('_x', self)))))
    except TypeError as te: self._check_types(ValueError("%s: '%s' when writing '%s'" % (type(te), str(te), str(locals().get('_x', self)))))

  def deserialize_numpy(self, str, numpy):
    """
    unpack serialized message in str into this message instance using numpy for array types
    :param str: byte array of serialized message, ``str``
    :param numpy: numpy python module
    """
    if python3:
      codecs.lookup_error("rosmsg").msg_type = self._type
    try:
      if self.timestamp is None:
        self.timestamp = genpy.Time()
      if self.position is None:
        self.position = foxglove_msgs.msg.Point2()
      if self.text_color is None:
        self.text_color = foxglove_msgs.msg.Color()
      if self.background_color is None:
        self.background_color = foxglove_msgs.msg.Color()
      end = 0
      _x = self
      start = end
      end += 24
      (_x.timestamp.secs, _x.timestamp.nsecs, _x.position.x, _x.position.y,) = _get_struct_2I2d().unpack(str[start:end])
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      start = end
      end += length
      if python3:
        self.text = str[start:end].decode('utf-8', 'rosmsg')
      else:
        self.text = str[start:end]
      _x = self
      start = end
      end += 72
      (_x.font_size, _x.text_color.r, _x.text_color.g, _x.text_color.b, _x.text_color.a, _x.background_color.r, _x.background_color.g, _x.background_color.b, _x.background_color.a,) = _get_struct_9d().unpack(str[start:end])
      self.timestamp.canon()
      return self
    except struct.error as e:
      raise genpy.DeserializationError(e)  # most likely buffer underfill

_struct_I = genpy.struct_I
def _get_struct_I():
    global _struct_I
    return _struct_I
_struct_2I2d = None
def _get_struct_2I2d():
    global _struct_2I2d
    if _struct_2I2d is None:
        _struct_2I2d = struct.Struct("<2I2d")
    return _struct_2I2d
_struct_9d = None
def _get_struct_9d():
    global _struct_9d
    if _struct_9d is None:
        _struct_9d = struct.Struct("<9d")
    return _struct_9d
