// Auto-generated. Do not edit!

// (in-package foxglove_msgs.msg)


"use strict";

const _serializer = _ros_msg_utils.Serialize;
const _arraySerializer = _serializer.Array;
const _deserializer = _ros_msg_utils.Deserialize;
const _arrayDeserializer = _deserializer.Array;
const _finder = _ros_msg_utils.Find;
const _getByteLength = _ros_msg_utils.getByteLength;
let Point2 = require('./Point2.js');
let Color = require('./Color.js');

//-----------------------------------------------------------

class TextAnnotation {
  constructor(initObj={}) {
    if (initObj === null) {
      // initObj === null is a special case for deserialization where we don't initialize fields
      this.timestamp = null;
      this.position = null;
      this.text = null;
      this.font_size = null;
      this.text_color = null;
      this.background_color = null;
    }
    else {
      if (initObj.hasOwnProperty('timestamp')) {
        this.timestamp = initObj.timestamp
      }
      else {
        this.timestamp = {secs: 0, nsecs: 0};
      }
      if (initObj.hasOwnProperty('position')) {
        this.position = initObj.position
      }
      else {
        this.position = new Point2();
      }
      if (initObj.hasOwnProperty('text')) {
        this.text = initObj.text
      }
      else {
        this.text = '';
      }
      if (initObj.hasOwnProperty('font_size')) {
        this.font_size = initObj.font_size
      }
      else {
        this.font_size = 0.0;
      }
      if (initObj.hasOwnProperty('text_color')) {
        this.text_color = initObj.text_color
      }
      else {
        this.text_color = new Color();
      }
      if (initObj.hasOwnProperty('background_color')) {
        this.background_color = initObj.background_color
      }
      else {
        this.background_color = new Color();
      }
    }
  }

  static serialize(obj, buffer, bufferOffset) {
    // Serializes a message object of type TextAnnotation
    // Serialize message field [timestamp]
    bufferOffset = _serializer.time(obj.timestamp, buffer, bufferOffset);
    // Serialize message field [position]
    bufferOffset = Point2.serialize(obj.position, buffer, bufferOffset);
    // Serialize message field [text]
    bufferOffset = _serializer.string(obj.text, buffer, bufferOffset);
    // Serialize message field [font_size]
    bufferOffset = _serializer.float64(obj.font_size, buffer, bufferOffset);
    // Serialize message field [text_color]
    bufferOffset = Color.serialize(obj.text_color, buffer, bufferOffset);
    // Serialize message field [background_color]
    bufferOffset = Color.serialize(obj.background_color, buffer, bufferOffset);
    return bufferOffset;
  }

  static deserialize(buffer, bufferOffset=[0]) {
    //deserializes a message object of type TextAnnotation
    let len;
    let data = new TextAnnotation(null);
    // Deserialize message field [timestamp]
    data.timestamp = _deserializer.time(buffer, bufferOffset);
    // Deserialize message field [position]
    data.position = Point2.deserialize(buffer, bufferOffset);
    // Deserialize message field [text]
    data.text = _deserializer.string(buffer, bufferOffset);
    // Deserialize message field [font_size]
    data.font_size = _deserializer.float64(buffer, bufferOffset);
    // Deserialize message field [text_color]
    data.text_color = Color.deserialize(buffer, bufferOffset);
    // Deserialize message field [background_color]
    data.background_color = Color.deserialize(buffer, bufferOffset);
    return data;
  }

  static getMessageSize(object) {
    let length = 0;
    length += _getByteLength(object.text);
    return length + 100;
  }

  static datatype() {
    // Returns string type for a message object
    return 'foxglove_msgs/TextAnnotation';
  }

  static md5sum() {
    //Returns md5sum for a message object
    return 'c519967875038307b79bf6d8fa469b37';
  }

  static messageDefinition() {
    // Returns full string definition for message
    return `
    # foxglove_msgs/TextAnnotation
    # A text label on a 2D image
    
    # Generated by https://github.com/foxglove/schemas
    
    # Timestamp of annotation
    time timestamp
    
    # Bottom-left origin of the text label in 2D image coordinates (pixels)
    foxglove_msgs/Point2 position
    
    # Text to display
    string text
    
    # Font size in pixels
    float64 font_size
    
    # Text color
    foxglove_msgs/Color text_color
    
    # Background fill color
    foxglove_msgs/Color background_color
    
    ================================================================================
    MSG: foxglove_msgs/Point2
    # foxglove_msgs/Point2
    # A point representing a position in 2D space
    
    # Generated by https://github.com/foxglove/schemas
    
    # x coordinate position
    float64 x
    
    # y coordinate position
    float64 y
    
    ================================================================================
    MSG: foxglove_msgs/Color
    # foxglove_msgs/Color
    # A color in RGBA format
    
    # Generated by https://github.com/foxglove/schemas
    
    # Red value between 0 and 1
    float64 r
    
    # Green value between 0 and 1
    float64 g
    
    # Blue value between 0 and 1
    float64 b
    
    # Alpha value between 0 and 1
    float64 a
    
    `;
  }

  static Resolve(msg) {
    // deep-construct a valid message object instance of whatever was passed in
    if (typeof msg !== 'object' || msg === null) {
      msg = {};
    }
    const resolved = new TextAnnotation(null);
    if (msg.timestamp !== undefined) {
      resolved.timestamp = msg.timestamp;
    }
    else {
      resolved.timestamp = {secs: 0, nsecs: 0}
    }

    if (msg.position !== undefined) {
      resolved.position = Point2.Resolve(msg.position)
    }
    else {
      resolved.position = new Point2()
    }

    if (msg.text !== undefined) {
      resolved.text = msg.text;
    }
    else {
      resolved.text = ''
    }

    if (msg.font_size !== undefined) {
      resolved.font_size = msg.font_size;
    }
    else {
      resolved.font_size = 0.0
    }

    if (msg.text_color !== undefined) {
      resolved.text_color = Color.Resolve(msg.text_color)
    }
    else {
      resolved.text_color = new Color()
    }

    if (msg.background_color !== undefined) {
      resolved.background_color = Color.Resolve(msg.background_color)
    }
    else {
      resolved.background_color = new Color()
    }

    return resolved;
    }
};

module.exports = TextAnnotation;
